package org.sap;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.util.List;
import java.util.Properties;
import java.util.Random;
import org.sap.MessageHandler;


public class FlightInformation
{

    String deptTime;
    String arrTime;
    String from;
    String to;
    String flighID;
    int noOfSeats = 10;
    int noOFSeatsbooked = 6;
    static int availablesSeats;
    static CustomerDetails customerDetails;
    static List<FlightInformation> flightInfoList;
    static FlightInformation flightInfo1 = null;
    static FlightInformation flightInfo2 = null;
    static Properties CONFIG = null;
    static FlightInformation finalFlight;
    int randNum;
    static String deptTime1 = "11.30 AM";
    static String NewDeptTime = "3.00 PM";
    static MessageHandler handler;
    static String appKey;
    static String appSecret;

    public void addFlightDetails(String flighID, String from, String to, String deptTime, String arrTime)
    {
        /*
         * if (noOfFlight < Max) { flights[noOfFlight] = new flightInfo(from,
         * to, deptTime, arrTime, totalCost); noOfFlight++; } else
         */
        this.flighID = flighID;
        this.from = from;
        this.to = to;
        this.deptTime = deptTime;
        this.arrTime = arrTime;

    }

    public String getfromCity()
    {
        return from;
    }

    public String getToCity()
    {
        return to;
    }

    public String getDeptTime()
    {
        return deptTime;
    }

    public String getArrTime()
    {
        return arrTime;
    }

    public String getflighID()
    {
        return flighID;
    }

    public FlightInformation searchFlight()
    {
        Random rand = new Random();
        randNum = rand.nextInt(2);
        if (randNum == 0)
        {
            return flightInfo1;
        }
        else
        {
            if (randNum == 1)
                return flightInfo2;
        }
        return null;
    }


    public void bookFlight(FlightInformation finalFlight) throws MalformedURLException, IOException
    {
        customerDetails.addCustomer(CONFIG.getProperty("customerFirstName"), CONFIG.getProperty("cusomerLastName"), CONFIG.getProperty("contactNo"), CONFIG.getProperty("customerUsername"));
        String messageString = "Hi  " + customerDetails.customerFirstName
                               + " your flight has been booked with seat Number: " + getAvailableSeatsAndAssign(1) + " from "
                               + finalFlight.searchFlight().getfromCity() + " to " + finalFlight.searchFlight().getToCity()
                               + " departuring at " + finalFlight.searchFlight().getDeptTime();


        // int account_number = #ACCOUNT_ID; //Replace with your account number.
        appKey = CONFIG.getProperty("appKey");
        appSecret = CONFIG.getProperty("appSecret");
        String destinationNumber = customerDetails.getCustomerMobNo(); //substitute with your destination number.
        handler.sendSMS( messageString, destinationNumber, handler.getAccessToken(appKey, appSecret));


    }


    public String getAvailableSeatsAndAssign(int NoOFpeople)
    {
        String FlightID = finalFlight.getflighID();
        boolean booked = false;
        availablesSeats = noOfSeats - noOFSeatsbooked;
        if (availablesSeats != 0 && availablesSeats >= NoOFpeople)
        {
            booked = true;
            Random rand = new Random();
            int seatNumberAssign = rand.nextInt(availablesSeats);
            return FlightID + "_" + seatNumberAssign;
        }
        else
        {
        }
        return (String) null;
    }

    public void modifyDepartTime(String NewDeptTime)
    {

        deptTime1 = NewDeptTime;
    }

    public String checkIfFlightIsDelayed()
    {
        if(finalFlight.searchFlight().getDeptTime() != NewDeptTime)
        {

            return deptTime1;
        }
        return arrTime;

    }


    public static void main(String args[]) throws MalformedURLException, IOException
    {
        CONFIG = new Properties();
        try
        {
            ClassLoader loader = Thread.currentThread().getContextClassLoader();
            CONFIG.load(loader.getResourceAsStream("config.properties"));

        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
        handler = new MessageHandler(CONFIG.getProperty("baseUrl"));
        flightInfo1 = new FlightInformation();
        flightInfo2 = new FlightInformation();
        flightInfo1.addFlightDetails(CONFIG.getProperty("flightID1"), CONFIG.getProperty("fromCity1"), CONFIG.getProperty("toCity1"), CONFIG.getProperty("deptTime1"), CONFIG.getProperty("arrTime1"));
        flightInfo2.addFlightDetails(CONFIG.getProperty("flightID2"), CONFIG.getProperty("fromCity2"), CONFIG.getProperty("toCity2"), CONFIG.getProperty("deptTime2"), CONFIG.getProperty("arrTime2"));
        customerDetails = new CustomerDetails();// get customer details
        finalFlight = flightInfo1.searchFlight();// search for flights
        flightInfo1.bookFlight(finalFlight); //book flight  and send SMS
        flightInfo1.modifyDepartTime(NewDeptTime);//this will modify the actual flight time
        flightInfo1.checkIfFlightIsDelayed();// it will check if flight is delayed and send SMS

    }
}